<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmployeeInfoType StructType
 * @package Dg
 * @subpackage Structs
 */
class DgEmployeeInfoType extends AbstractStructBase
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The EmployeeId
     * @var string
     */
    public $EmployeeId;
    /**
     * The EmployeeLevel
     * @var string
     */
    public $EmployeeLevel;
    /**
     * The EmployeeTitle
     * @var string
     */
    public $EmployeeTitle;
    /**
     * The EmployeeStatus
     * @var string
     */
    public $EmployeeStatus;
    /**
     * Constructor method for EmployeeInfoType
     * @uses DgEmployeeInfoType::set_()
     * @uses DgEmployeeInfoType::setEmployeeId()
     * @uses DgEmployeeInfoType::setEmployeeLevel()
     * @uses DgEmployeeInfoType::setEmployeeTitle()
     * @uses DgEmployeeInfoType::setEmployeeStatus()
     * @param string $_
     * @param string $employeeId
     * @param string $employeeLevel
     * @param string $employeeTitle
     * @param string $employeeStatus
     */
    public function __construct($_ = null, $employeeId = null, $employeeLevel = null, $employeeTitle = null, $employeeStatus = null)
    {
        $this
            ->set_($_)
            ->setEmployeeId($employeeId)
            ->setEmployeeLevel($employeeLevel)
            ->setEmployeeTitle($employeeTitle)
            ->setEmployeeStatus($employeeStatus);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \dgsoft\StructType\DgEmployeeInfoType
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get EmployeeId value
     * @return string|null
     */
    public function getEmployeeId()
    {
        return $this->EmployeeId;
    }
    /**
     * Set EmployeeId value
     * @param string $employeeId
     * @return \dgsoft\StructType\DgEmployeeInfoType
     */
    public function setEmployeeId($employeeId = null)
    {
        // validation for constraint: string
        if (!is_null($employeeId) && !is_string($employeeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($employeeId)), __LINE__);
        }
        $this->EmployeeId = $employeeId;
        return $this;
    }
    /**
     * Get EmployeeLevel value
     * @return string|null
     */
    public function getEmployeeLevel()
    {
        return $this->EmployeeLevel;
    }
    /**
     * Set EmployeeLevel value
     * @param string $employeeLevel
     * @return \dgsoft\StructType\DgEmployeeInfoType
     */
    public function setEmployeeLevel($employeeLevel = null)
    {
        // validation for constraint: string
        if (!is_null($employeeLevel) && !is_string($employeeLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($employeeLevel)), __LINE__);
        }
        $this->EmployeeLevel = $employeeLevel;
        return $this;
    }
    /**
     * Get EmployeeTitle value
     * @return string|null
     */
    public function getEmployeeTitle()
    {
        return $this->EmployeeTitle;
    }
    /**
     * Set EmployeeTitle value
     * @param string $employeeTitle
     * @return \dgsoft\StructType\DgEmployeeInfoType
     */
    public function setEmployeeTitle($employeeTitle = null)
    {
        // validation for constraint: string
        if (!is_null($employeeTitle) && !is_string($employeeTitle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($employeeTitle)), __LINE__);
        }
        $this->EmployeeTitle = $employeeTitle;
        return $this;
    }
    /**
     * Get EmployeeStatus value
     * @return string|null
     */
    public function getEmployeeStatus()
    {
        return $this->EmployeeStatus;
    }
    /**
     * Set EmployeeStatus value
     * @param string $employeeStatus
     * @return \dgsoft\StructType\DgEmployeeInfoType
     */
    public function setEmployeeStatus($employeeStatus = null)
    {
        // validation for constraint: string
        if (!is_null($employeeStatus) && !is_string($employeeStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($employeeStatus)), __LINE__);
        }
        $this->EmployeeStatus = $employeeStatus;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgEmployeeInfoType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
